<?php
if ( ! defined( 'ABSPATH' ) ) exit;
class Event_Registration_Pro_Event_CPT {
 
	    
		
		//Remove Add new from left menu	
		public function as_remove_menus(){
			global $submenu; 
			
			//Remove Event Categories link from admin left menu
			unset($submenu['edit.php?post_type=erp_event'][10]);
			
			//Remove Event categories tags metabox from right menu
			remove_meta_box( 'tagsdiv-erp-event-category','erp_event','normal' ); // Tags Metabox
		}
	
		/**
		* Callback for WordPress 'post_edit_form_tag' action.
		* 
		* Append enctype - multipart/form-data and encoding - multipart/form-data
		* to allow image uploads for post type 'post'
		* 
		* @global type $post
		* @return type
		*/
		public function add_post_enctype(){
		
			global $post;
			
			//  if invalid $post object, return
			if(!$post)
				return;
			
			//  get the current post type
			$post_type = get_post_type($post->ID);
			
			//  if post type is not 'post', return
			if('erp_event' != $post_type)
				return;
			
			//  append our form attributes
			printf(' enctype="multipart/form-data" encoding="multipart/form-data" '); 
		}
		
		
		/* Add custom column to post list */
		public function custom_posts_columns_header( $columns ) {
			 
			global $post, $typenow, $pagenow;  
			
			$imgpath =  plugin_dir_url( dirname( __FILE__ ) ) . 'admin/css/images/filesave.png'; 
			
			if($typenow=='erp_event'){
				unset($columns['date']); 
				
				 $orderby = trim(strip_tags(sanitize_text_field($_GET['orderby'])));
				 $order = trim(strip_tags(sanitize_text_field($_GET['order'])));
				 if($orderby=='erp_event_location'){

				 		if($order=='asc'){ $orderl='desc'; }else{ $orderl='asc';	}

				 }else{

				  $orderl='asc';
				}
				if($orderby=='erp_event_category'){

				 		if($order=='asc'){ $orderc='desc';}else{ $orderc='asc';	

				 	}
				 }else{
				  $orderc='asc';
				}
				if($orderby=='erp_event_date'){

				 		if($order=='asc'){ $orderd='desc';}else{ $orderd='asc';	}
				 }else{
				  $orderd='asc';
				}

				

				$str = "return fn_custom_save_order('erp_event_location')";


				return array_merge( $columns, 
					array( 'image' => __( 'Image', 'event-registration-pro' ), 
						'dates' => '<a href="'.admin_url().'edit.php?post_type=erp_event&orderby=erp_event_date&order='.$orderd.'"  >'.__( 'Dates', 'event-registration-pro' ).'</a>', 
						'location' =>'<a href="'.admin_url().'edit.php?post_type=erp_event&orderby=erp_event_location&order='.$orderl.'">'.__( 'Location', 'event-registration-pro' ).'</a>',
						'category' => '<a href="'.admin_url().'edit.php?post_type=erp_event&orderby=erp_event_category&order='.$orderc.'"  >'.__( 'Category', 'event-registration-pro' ).'</a>',
						'tickets' => __( 'Tickets', 'event-registration-pro' ),
						'order' => '<a href="javascript:void(0);" onclick="return save_order();"><img title="Save" alt="Save" src="'.$imgpath.'" /> '.__( 'Order', 'event-registration-pro' ).'</a> ',
						'id' => __( 'ID', 'event-registration-pro' )
					) 
				);
			}
			else if($typenow=='erp_organizers'){
				unset($columns['date']); 	
				return array_merge( $columns, 
					array( 'phone' => __( 'Phone', 'event-registration-pro' ), 
						'organizer_website' => __( 'Organizer Website', 'event-registration-pro' ),  
						'order' => __( '<a href="javascript:void(0);" onclick="return save_order();"><img title="Save" alt="Save" src="'.$imgpath.'" /> '.__( 'Order', 'event-registration-pro' ).'</a> ', 'event-registration-pro' ),
						'id' => __( 'ID', 'event-registration-pro' )
					) 
				);
			}
			else if($typenow=='erp_locations'){
				unset($columns['date']); 	
				return array_merge( $columns, 
					array( 'location_url' => __( 'Location Homepage', 'event-registration-pro' ), 
						'city_state' => __( 'City', 'event-registration-pro' ),  
						'order' => __( '<a href="javascript:void(0);" onclick="return save_order();"><img title="Save" alt="Save" src="'.$imgpath.'" /> '.__( 'Order', 'event-registration-pro' ).'</a> ', 'event-registration-pro' ),
						'id' => __( 'ID', 'event-registration-pro' )
					) 
				);
			}
			else if($typenow=='erp_email_template'){  
				unset($columns['date']);  
				return array_merge( $columns, 
					array( 'title' => __( 'Title', 'event-registration-pro' ), 
						'subject' => __( 'Subject', 'event-registration-pro' ), 
						'type' => __( 'Type', 'event-registration-pro' ),   
						'id' => __( 'ID', 'event-registration-pro' )
					) 
				);  
			}
			else
			{
				return $columns;
			}

		}
		
		/* Custom column content */
	
		public function custom_posts_columns_body( $column_name)
		{
			
			global $post, $typenow, $pagenow;   
			 $post_ID = $post->ID;
			 $order_post_ID = $post->ID; 
			/*For Arrow*/	
			 $orderby = trim(strip_tags(sanitize_text_field($_GET['orderby'])));	
				 $order = trim(strip_tags(sanitize_text_field($_GET['order'])));
			      if($typenow=='erp_event' && $column_name == 'category')
					{  
						if($orderby=='erp_event_category'){
							if($order=='asc'){ 
							echo '<script>jQuery("#category").removeClass("desc");jQuery("#category").addClass("asc");</script>';
							}
							if($order=='desc'){ 
							echo '<script>jQuery("#category").removeClass("asc");jQuery("#category").addClass("desc");</script>';
							}
						}
					}
					if($typenow=='erp_event' && $column_name == 'location')
					{  
						if($orderby=='erp_event_location'){
							if($order=='asc'){ 
							echo '<script>jQuery("#location").removeClass("desc");jQuery("#location").addClass("asc");</script>';
							}
							if($order=='desc'){ 
							echo '<script>jQuery("#location").removeClass("asc");jQuery("#location").addClass("desc");</script>';
							}
						}
					}
					if($typenow=='erp_event' && $column_name == 'dates')
					{  
						if($orderby=='erp_event_date'){
							if($order=='asc'){ 
							echo '<script>jQuery("#dates").removeClass("desc");jQuery("#dates").addClass("asc");</script>';
							}
							if($order=='desc'){ 
							echo '<script>jQuery("#dates").removeClass("asc");jQuery("#dates").addClass("desc");</script>';
							}
						}
					}     
				/*For Arrow*/		 
			if($typenow=='erp_event')
			{
				if ($column_name == 'image') 
				{
					//$post_thumbnail_id = get_post_thumbnail_id($post_ID);
					$post_thumbnail_id = get_post_meta($post_ID,'erp_event_thumbnail_image',true); 
					$image_src = wp_get_attachment_url( $post_thumbnail_id ); 
					//$this->get_featured_image($post_thumbnail_id);
					if ($image_src) {
						echo '<img src="' . $image_src . '" height="75" width="75" />'; 
					}
				}
				else if ($column_name == 'dates') 
				{
					$event_display_settings=array();
				  	$event_display_settings = get_option("erp_event_display_settings"); 
				  	$timeformat=$event_display_settings['erp_event_display_settings_formattime'];
					$event_start_date = get_post_meta($post_ID,'erp_event_date',true); 
					$event_end_date = get_post_meta($post_ID,'erp_event_enddate',true); 
					$event_start_time = get_post_meta($post_ID,'erp_event_time',true); 
					$event_end_time = get_post_meta($post_ID,'erp_event_endtime',true);
					$event_start_timeformat = date($timeformat, strtotime($event_start_time)); 
					$event_end_timeformat = date($timeformat, strtotime($event_end_time)); 
					
					
					$eStart_date =dateformat_function($event_start_date); 
					$eEnd_date = dateformat_function($event_end_date); 
					 
					if($event_start_date!='' && $event_end_date!=''){ 
						echo $eStart_date.' '.$event_start_timeformat; 
						if($eEnd_date!=''){
							echo ' - '.$eEnd_date.' '.$event_end_timeformat;
						} 
					}
					if($post->post_status=='publish'){
						
					do_action('show_duplicate_event',$post_ID);
					}
					
				}
				else if ($column_name == 'location') 
				{
					$location_id = get_post_meta($post_ID,'erp_event_location',true); 
					if($location_id > 0){
						echo $location = '<div class="tbl-td-loc" data-loc="'.$location_id.'">'.get_the_title($location_id).'</div>';
					}
				}
				else if ($column_name == 'category') 
				{
					$category_id = get_post_meta($post_ID,'erp_event_category',true); 
					if($category_id > 0){
						$category = get_term($category_id,'erp-event-category');
						echo $category->name;
					}
				}
				else if ($column_name == 'tickets') 
				{
					 global $post;
					
							  $args = array(											
											'post_type' => 'register_events',
											'posts_per_page' => '-1',
											'meta_query'     => array(
													array (
													   'key'     => 'post_id',
													   'value'   =>$post_ID,
													   'compare' => '=',
													 )
												),
										); 	
                
        						$res = new WP_Query( $args );
								
								$args1 = array(											
											'post_type' => 'register_events',
											'posts_per_page' => '-1',
											'meta_query'     => array(
													array (
													   'key'     => 'accepted',
													   'value'   =>1,
													   'compare' => '=',
													 ),
													 array (
													   'key'     => 'post_id',
													   'value'   =>$post_ID,
													   'compare' => '=',
													 )
												),
										); 	
                
        						$res1 = new WP_Query( $args1 );
								
     							 $accepted_count= $res1->post_count;
								
     							 $register_count= $res->post_count;
								$pending_count = $register_count - $accepted_count;
								$erp_event_max_attendance = get_post_meta($post_ID,'erp_event_max_attendance',true); 
								 
									
								 ?>
                                 <table id="eventTicketsShow">
                                    <tbody><tr>
                                    <th>Name</th>
                                    <th width="45" style="text-align:center;">Sold</th>
                                    </tr>
                                    <?php 
									$addon_tkt_url=get_option('ticket_addon_plg_license');
									if ( !empty( $addon_tkt_url ) ):
									do_action('show_ticket_on_backend_event_manager_event_registration_pro_ticket_standard');
									else:
									?>
                                    <tr valign="top" id="tickets_row">
                                    <td valign="top">Free Administrator</td>
                                    <td style="text-align:center;color:#06a;vertical-align:top;" valign="top">
                                    <span class="editlinktip hasTip" title=""><?php echo $register_count;?> / 
                                    <span id="infinity_symbol" class="ssdsd"><?php echo(!empty($erp_event_max_attendance))? $erp_event_max_attendance : '&#8734' ;?></span>
                                    </span>
                                    </td>
                                    </tr>
									<?php 
									$total_event_income1=0;
									
									?>
									<tr><td colspan="2" style="background-color:#ccc;padding:0px;margin:0px;height:0px;"></td></tr>
									 <tr><td colspan="2">
									 <div style="margin-bottom:6px;font-style:bold;font-weight:700;margin-top:2px;">Total: $<?php echo $total_event_income1;?></div></td></tr>
									
									<?php endif; ?>
                                    
                                    
                                    
                                    <tr><td stye="text-align:left;">
                                   
                                    <?php if(!empty($register_count)){?>
                                        <a href="edit.php?post_type=erp_event&page=register-report-view&event_id=<?php echo $post_ID ;?>" title="View Registrant List">
                                        <?php if(!empty($accepted_count)){?>
                                        Accepted: <?php echo $accepted_count;?><br>
                                         <?php } if(!empty($pending_count)){?>
                                        Pending: <?php echo $pending_count;?><br>
                                        <?php } ?>
                                        Total: <?php echo $register_count; ?>
										<?php echo(!empty($erp_event_max_attendance))? '/ '.$erp_event_max_attendance : '' ;?>
                                        </a>
                                     <?php } ?>   
                                    </td>								
										<td style="text-align:center;" align="center">
												<span class="editlinktip hasTip" title="">
													<a href="#" onclick="add_registrants_icon(<?php echo $post_ID;?>)">
													<h3><i class="fa fa-user-plus" aria-hidden="true"></i></h3>
													</a>
												</span>
											</td></tr>
								</tbody></table>
								<?php $nonce = wp_create_nonce( 'erp-nonce' );?>
                                <script>
								function add_registrants_icon(event_id){
						
										var event_id=event_id;
									    var nonce='<?php echo $nonce;?>';
										jQuery.ajax({
											url: "<?php echo admin_url().'admin-ajax.php' ?>?funct=add_registrants",
											type: "POST",
											data: { event_id:event_id,nonce:nonce},
											success: function(result){
												
												jQuery('.wrap').html(result);
																			
											}
										}); 
									
									}
									</script>
								<?php 
								
				}
				else if ($column_name == 'order') 
				{ 
						$post_id=get_post_meta($post_ID,'post_id');
					
					if(empty($post_id[0])){$order_post_ID= $post->ID;}else{$order_post_ID= $post_id[0];}
					$thispost = get_post($order_post_ID);
					$menu_order = $thispost->menu_order;
					
					echo $views = '<input type="text" name="postorder[]" id="'.$order_post_ID.'" class="postorder" value="'.$menu_order.'" />';
 				}
				else if ($column_name == 'id') 
				{	$post_id=get_post_meta($post_ID,'post_id');
					
					if(empty($post_id[0])){echo $post->ID;}else{echo $post_id[0];}
					
				}
			}
			else if($typenow=='erp_organizers')
			{ 
				if ($column_name == 'phone') {
					echo $phone = get_post_meta($post_ID,'erp_event_organizer_phone',true); 
				}
				else if ($column_name == 'organizer_website') {
					echo $website = get_post_meta($post_ID,'erp_event_organizer_website',true); 
				}
				else if ($column_name == 'order') {
					echo $views = '<input type="text" name="postorder[]" id="'.$post_ID.'" class="postorder" value="'.$post->menu_order.'" />';
				}
				else if ($column_name == 'id') {
					echo $post_ID;
				} 
			}
			else if($typenow=='erp_locations')
			{
				if ($column_name == 'location_url') {
					echo $location_url = get_post_meta($post_ID,'erp_event_location_manager_location_url',true); 
				}
				else if ($column_name == 'city_state') {
					echo $city_state = get_post_meta($post_ID,'erp_event_location_manager_city_state',true); 
				}
				else if ($column_name == 'order') {
					echo $views = '<input type="text" name="postorder[]" id="'.$post_ID.'" class="postorder" value="'.$post->menu_order.'" />';
				}
				else if ($column_name == 'id') {
					echo $post_ID;
				} 
			}
			else if($typenow=='erp_email_template')
			{    
			
				if ($column_name == 'subject') {
					echo $subject = get_post_meta($post_ID,'erp_email_template_subject',true); 
				}
				else if ($column_name == 'type') {
					echo $type = get_post_meta($post_ID,'erp_email_template_registrant_confirmation',true); 
				}
				else if ($column_name == 'id') {
					echo $post_ID;
					 $static= get_post_meta($post_ID,'erp_email_template_static',true);
					 if($static == 'static_email_template'){
					?>
					<script>jQuery("#cb-select-<?php echo $post_ID;?>").remove();
							jQuery(".post-<?php echo $post_ID;?> span.trash").remove();
                    </script>
					
					<?php }
				} 
			}
		}
		
		/* Add sortable columns */ 
		public function custom_posts_sortable_columns( $columns ) {
			 
			 global $post, $typenow, $pagenow; 
			 
				 
					
			 
			 if($typenow=='erp_event'){
				 return array(
				 	'title'	=> 'title',
					'order' => 'order',
					'dates' => 'dates',
					'location' => 'location',
					'category' => 'category',
					'id'    => 'id'
				  );
			 } 
			 else if($typenow=='erp_organizers')
			 {
				  return array(
					'title'	=> 'title',
					'order' => 'order',
					'id'    => 'id'
				  );
			 }
			 else if($typenow=='erp_locations')
			 {
				  return array(
					'title'	=> 'title',
					'order' => 'order',
					'id'    => 'id'
				  );
			 }
			 else if($typenow=='erp_email_template'){
				 return array(
				 	'title'	=> 'title', 
					'id'    => 'id'
				  );
			 }
			 else
			 {
				return $columns;
			 }

		} 
		
		/* Set list view orderby query */
		public function custom_sortable_posts_orderby($orderby)
		{
			global $wpdb, $post, $typenow, $pagenow; 
			
			if(isset($_GET['orderby']) && isset($_GET['order']) && ($typenow=='erp_event'))
			{
				 $orderby = trim(strip_tags(sanitize_text_field($_GET['orderby'])));	
				 $order = trim(strip_tags(sanitize_text_field($_GET['order'])));
				 //$orderby_meta_key = trim(strip_tags(sanitize_text_field($_GET['orderby_meta_key'])));
				  

				if($typenow=='erp_event')
				{  
					if($orderby=='id'){
						$orderby = "{$wpdb->posts}.ID ".$order;
					}
					else if($orderby=='order')
					{
						$orderby = "{$wpdb->posts}.menu_order ".$order;
					}
					else if($orderby=='title')
					{
						$orderby = "{$wpdb->posts}.post_title ".$order;
					}
					else if($orderby=='erp_event_location')
					{    
						$orderby = " L1.post_title ".$order;
					}
					else if($orderby=='erp_event_category')
					{
						 $orderby = " T1.name ".$order;
					}
					else if($orderby=='erp_event_date')
					{
						 $orderby = " mt2.meta_value ".$order;
						 //$orderby = " STR_TO_DATE(DD.date_due,'%Y/%m/%d') ASC ";
					} 
					//echo $wpdb->last_query;
				}
				else if($typenow=='erp_organizers')
				{
					if($orderby=='id'){
						$orderby = "{$wpdb->posts}.ID ".$order;
					}
					else if($orderby=='order')
					{
						$orderby = "{$wpdb->posts}.menu_order ".$order;
					}
					else if($orderby=='title')
					{
						$orderby = "{$wpdb->posts}.post_title ".$order;
					}
				}
				else if($typenow=='erp_locations')
				{
					if($orderby=='id'){
						$orderby = "{$wpdb->posts}.ID ".$order;
					}
					else if($orderby=='order')
					{
						$orderby = "{$wpdb->posts}.menu_order ".$order;
					}
					else if($orderby=='title')
					{
						$orderby = "{$wpdb->posts}.post_title ".$order;
					}
				} 	
			} 
			
			return($orderby);
		} 
		


		// Get featured image
		public function get_featured_image($post_thumbnail_id) {
			
			if ($post_thumbnail_id) {
				 $post_thumbnail_img = wp_get_attachment_image_src($post_thumbnail_id, 'thumbnail');
				 return $post_thumbnail_img[0];
			}
		}  
		
		/////////////////////////////////////////////Show Category Columns/////////////////////////////
		/**
		 * Thumbnail column added to category admin.
		 *
		 * @access public
		 * @param mixed $columns
		 * @return void
		 */
		 public function erp_event_taxonomy_columns( $columns ) { 
			 
			$new_columns = array();
			$new_columns['cb'] = $columns['cb'];
			$new_columns['thumb'] = __('Image', 'event-registration-pro');
		
			unset( $columns['cb'] );
		
			return array_merge( $new_columns, $columns );
		}
		
		/**
		 * Thumbnail column value added to category admin.
		 *
		 * @access public
		 * @param mixed $columns
		 * @param mixed $column
		 * @param mixed $id
		 * @return void
		 */
		 public function erp_event_taxonomy_column( $columns, $column, $id ) {
			   
			if ( $column == 'thumb' )
				$cat_meta = get_option("erp_event_category_".$id);  
				
				$imgid = $cat_meta['erp_event_category_image_url'];
				$columns = '<span><img src="' .$this->get_featured_image($imgid) . '" alt="' . __('Thumbnail', 'event-registration-pro') . '" width="75" height="75" class="wp-post-image" /></span>';
			
			return $columns;
		 } 
		/////////////////////////////////////////////////////////////////////////////////////////////// 
		
		
		/**
		 * Submenu filter function. Tested with Wordpress 4.1.1
		 * Sort and order submenu positions to match your custom order.
		 *
		 * @author Hendrik Schuster <contact@deviantdev.com>
		 */
		
		 public function order_index_catalog_menu_page( $menu_ord ) {
			global $submenu;
			
		
			// Sort the menu according to your preferences 
			$addon_offline_payment_url=get_option('offline_payment_plg');
			$event_discount_plg_url=get_option('event_discount_plg');
			if ( is_plugin_active( $addon_offline_payment_url ) && empty($event_discount_plg_url)){
							
				do_action('addon_show_backend_left_menu_event_registration_offline_payment');
				
			}else if(is_plugin_active( $event_discount_plg_url )){
								
				do_action('addon_show_backend_left_menu');
					}else{
	
		
			$arr[16] = $submenu['edit.php?post_type=erp_event'][16];
			$arr[17] = $submenu['edit.php?post_type=erp_event'][17]; 
			$arr[22] = $submenu['edit.php?post_type=erp_event'][22]; 
			$arr[5]  = $submenu['edit.php?post_type=erp_event'][5]; 
			$arr[15] = $submenu['edit.php?post_type=erp_event'][15];
			$arr[19] = $submenu['edit.php?post_type=erp_event'][19];
			$arr[20] = $submenu['edit.php?post_type=erp_event'][20];
			$arr[21] = $submenu['edit.php?post_type=erp_event'][21]; 
			$arr[27] = $submenu['edit.php?post_type=erp_event'][27];
			$arr[18] = $submenu['edit.php?post_type=erp_event'][18];
			
			//$arr[23] = $submenu['edit.php?post_type=erp_event'][23];
			$submenu['edit.php?post_type=erp_event'] = $arr; 
		    return $menu_ord; 
			}
		}
		/////////////////////////////////////////////////////////////////////////////////////////////// 
}	
 