<?php
if ( ! defined( 'ABSPATH' ) ) exit;
class Event_Registration_Pro_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {

	}
	function insert_record_emails(){
    	global $wpdb;	
		$Post_Title_Check = get_page_by_title('Event Admin Notification', OBJECT, 'erp_email_template' );
		if($Post_Title_Check->ID == '' && empty($Post_Title_Check)) {   
        $my_post = array(
	        'post_title'    => 'Event Admin Notification',
	        'post_content'  => 'This is my Event Admin Notification Details.',
	        'post_status'   => 'publish',
	        'post_author'   => 1,
	        'post_type' =>'erp_email_template',
	        'post_category' => array( 8,39 )
	    );
	    $rs_first=wp_insert_post( $my_post );
		}
	    if ( is_wp_error( $rs_first ) ) {
	        // Error handling
	    } else {
	        // the rest of your code, inserting metadata
	        update_post_meta( $rs_first, 'erp_email_template_subject', 'Event Admin Notification - New event registration to: {eventtitle}' );
	        update_post_meta( $rs_first, 'erp_email_template_registrant_confirmation', 'Admin Notification' );
			update_post_meta( $rs_first, 'erp_email_template_registrant_confirmation', 'Admin Notification' );
			update_post_meta($rs_first, 'erp_email_template_static', 'static_email_template');
			update_post_meta($rs_first, 'erp_email_template_selection', 'admin_notification_tmpl');
	        update_post_meta( $rs_first, 'erp_email_template_email_body', "Dear Event Admin of {sitename},

			{fullname} has registered to the event: {eventtitle}

			Note: You are receiving this email because your email is entered as the admin notification email in the event system's configuration settings.

			The registration details are:

			{registrationdetails}
			" );
			    }
	
  
			$Post_Title_Check1 = get_page_by_title('Pending Registration Followup', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check1->ID == '' && empty($Post_Title_Check1)) {	 
				$my_post = array(
					'post_title'    => 'Pending Registration Followup',
					'post_content'  => 'This is my Pending Registration Followup Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_second=wp_insert_post( $my_post );
			 }
		    if ( is_wp_error( $rs_second ) ) {
		        // Error handling
		    } else {
		        // the rest of your code, inserting metadata
		        update_post_meta( $rs_second, 'erp_email_template_subject', 'Your event registration is incomplete for {eventtitle}' );
		        update_post_meta( $rs_second, 'erp_email_template_registrant_confirmation', 'Pending Registration' );
				update_post_meta($rs_second, 'erp_email_template_static', 'static_email_template');
				update_post_meta($rs_first, 'erp_email_template_selection', 'pending_registration_tmpl');
		        update_post_meta( $rs_second, 'erp_email_template_email_body', "Hello {fullname},

				We have noticed that you started to register to {eventtitle} and your registration is in pending status and currently incomplete.

				Please click the following link to complete your event registsration.

				{resumepaymentlink}

				If you are having problems with your registration please contact us and we will be happy to assist you.

				Regards,
				{sitename}" );
			}
		    $Post_Title_Check2 = get_page_by_title('Event Moderator Template', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check2->ID == '' && empty($Post_Title_Check2)) {	
				$my_post = array(
					'post_title'    => 'Event Moderator Template',
					'post_content'  => 'This is my Event Moderator Template Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_third=wp_insert_post( $my_post );
			}
		    if ( is_wp_error( $rs_third ) ) {
		        // Error handling
		    } else {
		        // the rest of your code, inserting metadata
		        update_post_meta( $rs_third, 'erp_email_template_subject', 'Event Moderator - A new event requires moderation' );
		        update_post_meta( $rs_third, 'erp_email_template_registrant_confirmation', 'Moderator' );
				update_post_meta($rs_third, 'erp_email_template_static', 'static_email_template');
				update_post_meta($rs_first, 'erp_email_template_selection', 'event_moderator_tmpl');
		        update_post_meta( $rs_third, 'erp_email_template_email_body', 'A new event has been created by a front end user and this event requires moderation before it can be publised.

			The event is named: {eventtitle}

			Please review the event and publish as neccesary.' );
			    }
			$Post_Title_Check3 = get_page_by_title('Registrant Confirmation Template', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check3->ID == '' && empty($Post_Title_Check3)) {	
				$my_post = array(
					'post_title'    => 'Registrant Confirmation Template',
					'post_content'  => 'This is my Event Registrant Confirmation Template Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_four=wp_insert_post( $my_post );
			}
		    if ( is_wp_error( $rs_four ) ) {
		        // Error handling
		    } else {
		        // the rest of your code, inserting metadata
		        update_post_meta( $rs_four, 'erp_email_template_subject', 'Congratulations! You are registered to {eventtitle}' );
		        update_post_meta( $rs_four, 'erp_email_template_registrant_confirmation', 'Registrant Confirmation' );
				update_post_meta($rs_first, 'erp_email_template_selection', 'registrant_confirmation_tmpl');
				//update_post_meta($rs_four, 'erp_email_template_static', 'static_email_template');
		        update_post_meta( $rs_four, 'erp_email_template_email_body', 'Dear {fullname}, 
				You have been successfuly registered to the event named: {eventtitle}

				This event will take placeon {eventstart} at {location}.

				We look forward to seeing your there.

				We have the following registration details on file for your registration.

				{registrationdetails}

				{transactiondetails}' );
		    }
			$Post_Title_Check4 = get_page_by_title('Organizer Notification Template', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check4->ID == '' && empty($Post_Title_Check4)) {	
				   $my_post = array(
					'post_title'    => 'Organizer Notification Template',
					'post_content'  => 'This is my Event Organizer Notification Template Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_five=wp_insert_post( $my_post );
			}
		    if ( is_wp_error( $rs_five ) ) {
		        // Error handling
		    } else {
		        // the rest of your code, inserting metadata
		        update_post_meta( $rs_five, 'erp_email_template_subject', 'Event Organizer Notification - New event registration to: {eventtitle}' );
		        update_post_meta( $rs_five, 'erp_email_template_registrant_confirmation', 'Organizer Confirmation' );
				update_post_meta($rs_first, 'erp_email_template_selection', 'organizer_confirmation_tmpl');
				//update_post_meta($rs_five, 'erp_email_template_static', 'static_email_template');
		        update_post_meta( $rs_five, 'erp_email_template_email_body', 'Dear Event Organizer,

				{fullname} has registered to the event: {eventtitle}

				Note: You are receiving this email because your email is entered as the organizer notification email in the event system`s settings for the above mentioned event.

				The registration details are:

				{registrationdetails} ' );
			}
			$Post_Title_Check5 = get_page_by_title('Reminder Template', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check5->ID == '' && empty($Post_Title_Check5)) {	
				 $my_post = array(
					'post_title'    => 'Reminder Template',
					'post_content'  => 'This is my Event Reminder Template Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_six=wp_insert_post( $my_post );
			}
		    if ( is_wp_error( $rs_six ) ) {
		        // Error handling
		    } else {
	        // the rest of your code, inserting metadata
	        update_post_meta( $rs_six, 'erp_email_template_subject', 'Reminder for {eventtitle}' );
	        update_post_meta( $rs_six, 'erp_email_template_registrant_confirmation', 'Reminder Notification' );
			update_post_meta($rs_first, 'erp_email_template_selection', 'reminder_confirmation_tmpl');
			//update_post_meta($rs_six, 'erp_email_template_static', 'static_email_template');
	        update_post_meta( $rs_six, 'erp_email_template_email_body', 'Hello {fullname},

			This is a reminder that you are registered to the event {eventtitle}.

			The event will start on {eventstart}.

			We look forward to seeing you there.

			Regards,
			The event managment team ' );
   		 }
			$Post_Title_Check6 = get_page_by_title('Invoice', OBJECT, 'erp_email_template' );
		    if($Post_Title_Check6->ID == '' && empty($Post_Title_Check6)) {	
				$my_post = array(
					'post_title'    => 'Invoice',
					'post_content'  => 'This is my Event Reminder Template Details.',
					'post_status'   => 'publish',
					'post_author'   => 1,
					'post_type' =>'erp_email_template',
					'post_category' => array( 8,39 )
				);
				$rs_last=wp_insert_post( $my_post );
			}
		    if ( is_wp_error( $rs_last ) ) {
		        // Error handling
		    } else {
		        // the rest of your code, inserting metadata
		        update_post_meta( $rs_last, 'erp_email_template_subject', 'Invoice for registration to {eventtitle}' );
		        update_post_meta( $rs_last, 'erp_email_template_registrant_confirmation', 'Invoice' );
				update_post_meta($rs_first, 'erp_email_template_selection', 'invoice_confirmation_tmpl');
				//update_post_meta($rs_six, 'erp_email_template_static', 'static_email_template');
		        update_post_meta( $rs_last, 'erp_email_template_email_body', '
				<p>Thanks for registering and your payment for {eventtitle},</p>
				<p>Your invoice details are below.</p>
				<table>
				<tbody>
				<tr>
				<td><strong>Registrant Name:</strong></td>
				<td>{fullname}</td>
				</tr>
				<tr>
				<td><strong>Event Name:</strong></td>
				<td>{eventtitle}</td>
				</tr>
				<tr>
				<td><strong>Registration ID #:</strong></td>
				<td>{registrationid}</td>
				</tr>
				</tbody>
				</table>
				<p>{transactiondetails}</p> ' );
		    }
		}
    function auto_nav_creation_primary(){
	
	/*main setting save */
	/*general_setting*/
	global $wp_rewrite;
	update_option('permalink_structure','/%postname%/');
	$wp_rewrite->set_permalink_structure('/%postname%/');
	
	$general_setting=get_option('erp_event_general_settings');
	if(empty($general_setting)){
		$event_general_settings['erp_event_general_settings_boot_style']='Yes';
		update_option('erp_event_general_settings',$event_general_settings);
    }else{
    	update_option('erp_event_general_settings',$general_setting);
    }
	update_option( 'admin_popup','term_condition' );	
	/*Event Handling*/
	$event_handling1=get_option('erp_event_handling');
	if(empty($event_handling1)){
	$event_handling['erp_event_handling_archiveby']='Event end date';
	$event_handling['erp_event_handling_oldevent']='Archive old events';
	$event_handling['erp_event_handling_disable_remiders']='No';
	$event_handling['erp_event_handling_minus']='0';
	update_option('erp_event_handling',$event_handling); 
	}else{
		update_option('erp_event_handling',$event_handling1);
	}
	
	/*Registration Handling*/
	$registartion_handling1=get_option('erp_event_registration_settings');
	if(empty($registartion_handling1)){
	$registartion_handling['erp_event_registration_settings_duplicate_email_registration']='Yes';
	$registartion_handling['erp_event_registration_settings_include_pending_reg']='Yes';
	$registartion_handling['erp_event_registration_settings_default_email_to_pending_reg']='Yes';
	$registartion_handling['erp_event_registration_settings_default_email_to_pending_reg_days']='0';
	$registartion_handling['erp_event_registration_settings_delete_pending_reg']='No';
	$registartion_handling['erp_event_registration_settings_default_delete_days']='0';
	
	update_option('erp_event_registration_settings',$registartion_handling);
	}else{

		update_option('erp_event_registration_settings',$registartion_handling1);
	}
	/*display setting*/
	$display_settings1=get_option('erp_event_display_settings');
	if(empty($display_settings1)){
 	$display_settings['erp_event_display_settings_eventlistordering'] = 'Event Title';
	$display_settings['erp_event_display_settings_showhead'] = 'Yes';
	$display_settings['erp_event_display_settings_show_footer'] = 'Yes';
	$display_settings['erp_event_display_settings_listing_button'] = 'Accordion Category View';
	$display_settings['erp_event_display_settings_formatdate'] = 'M j, Y';
	$display_settings['erp_event_display_settings_formattime'] = 'g:i, a';
	$display_settings['erp_event_display_settings_timezone_offset'] = 'America/Chicago';
	$display_settings['erp_event_display_settings_rss_enable'] = 'Yes';
	$display_settings['erp_event_display_settings_thankspagelink'] = '';
	$display_settings['erp_event_display_settings_event_terms_and_conditions'] = 'Yes';
	$display_settings['erp_event_display_settings_accepted_registration_reports'] = 'Yes';
	$display_settings['erp_event_display_settings_featured_bg_color'] = '94FFA6';
	$display_settings['erp_event_display_settings_featured_text_color'] = '000000';
	$display_settings['erp_event_display_settings_showeventdates'] ='Yes';
	$display_settings['erp_event_display_settings_showeventtimes'] ='Yes';
	$display_settings['erp_event_display_settings_showlocationcolumn'] ='Yes';
	$display_settings['erp_event_display_settings_showshortdescriptioncolumn'] ='Yes';
	$display_settings['erp_event_display_settings_showcategory1'] ='Yes';
	$display_settings['erp_event_display_settings_maxseat'] ='Yes';
	$display_settings['erp_event_display_settings_pendingseat'] ='Yes';
	$display_settings['erp_event_display_settings_registeredseat'] ='Yes';
	$display_settings['erp_event_display_settings_show_poster_cal'] = 'No';
	$display_settings['erp_event_display_settings_show_all_dates_in_calendar'] ='Yes';
	$display_settings['erp_event_display_settings_calendar_weekday'] = 'Sunday';
	$display_settings['erp_event_display_settings_show_max_seats_on_details_page'] ='Yes';
	$display_settings['erp_event_display_settings_show_avaliable_seats_on_details_page'] ='Yes';
	$display_settings['erp_event_display_settings_show_registered_seats_on_details_page']='Yes';
	$display_settings['erp_event_display_settings_showtime'] ='Yes';
    $display_settings['erp_event_display_settings_showevdesc'] ='Yes';
    $display_settings['erp_event_display_settings_showtitle'] ='Yes';
    $display_settings['erp_event_display_settings_showlocation'] ='Yes';
    $display_settings['erp_event_display_settings_showurl'] ='Yes';
    $display_settings['erp_event_display_settings_showmapserv'] ='Yes';
    $display_settings['erp_event_display_settings_showcategory'] ='Yes';
   
    $display_settings['erp_event_display_settings_session_dateformat'] ='M j, Y';
    $display_settings['erp_event_display_settings_session_timeformat'] ='g:i, a';
    $display_settings['erp_event_display_settings_circle_bg_color'] ='656464';
    $display_settings['erp_event_display_settings_days'] ='Days';
    $display_settings['erp_event_display_settings_days_color'] ='3C76FC';
    $display_settings['erp_event_display_settings_hours'] ='Hours';
    $display_settings['erp_event_display_settings_hours_color'] ='53FE5A';
    $display_settings['erp_event_display_settings_mins'] = 'Minites';
    $display_settings['erp_event_display_settings_mins_color'] ='FF6505';
    $display_settings['erp_event_display_settings_secs'] ='second';
    $display_settings['erp_event_display_settings_sec_color'] ='FE1EFA';
    $display_settings['erp_event_display_settings_cats_limit'] = '4';
    $display_settings['erp_event_display_settings_cats_per_row'] ='4';
    $display_settings['erp_event_display_settings_show_catimage'] ='Yes';
    $display_settings['erp_event_display_settings_show_catname'] ='Yes';
    $display_settings['erp_event_display_settings_show_noevent'] ='Yes';
    $display_settings['erp_event_display_settings_show_shortdesc'] ='Yes';
    $display_settings['erp_event_display_settings_show_viewevent'] ='Yes';
	update_option('erp_event_display_settings',$display_settings);
	}else{
		update_option('erp_event_display_settings',$display_settings1);
	}
	/*Image setting*/
	$image_setting1=get_option('erp_event_image_settings');
	if(empty($image_setting1)){
	$image_setting['erp_event_image_settings_show_poster'] ='Yes';
    $image_setting['erp_event_image_settings_event_thumb_width'] =''; 
    $image_setting['erp_event_image_settings_event_thumb_height'] ='';
    $image_setting['erp_event_image_settings_thumb_height_auto']='Yes';
    $image_setting['erp_event_image_settings_show_banner'] ='Yes';
    $image_setting['erp_event_image_settings_event_banner_width'] ='';
    $image_setting['erp_event_image_settings_event_banner_height'] =''; 
    $image_setting['erp_event_image_settings_banner_height_auto']='Yes';
    $image_setting['erp_event_image_settings_cat_image_width'] ='';
    $image_setting['erp_event_image_settings_cat_image_height'] ='';
    $image_setting['erp_event_image_settings_cat_height_auto'] ='Yes';
 	update_option('erp_event_image_settings',$image_setting);
	 }else{
	 	update_option('erp_event_image_settings',$image_setting1);
	 }
	$pageName = 'Erp Cart';
		if( get_page_by_title( $pageName ) == NULL ){			
			$createPage = array(
			  'post_title'    => $pageName,
			  'post_content'  => '[Event_Cart]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pageName
			);  
			$page_id =  wp_insert_post( $createPage );
			update_option( 'event_cart_page_id', $page_id );
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$cart_page=$event_general_settings['erp_event_general_settings_cart_page_url'];
			if(empty($cart_page)){
			$event_general_settings['erp_event_general_settings_cart_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings); 
		}
	$pagecheck = 'Erp Checkout';
		if( get_page_by_title( $pagecheck ) == NULL ){			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Event_Checkout]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			);	 
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'event_checkout_page_id', $page_id );
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$check_page=$event_general_settings['erp_event_general_settings_checkout_page_url'];
			if(empty($check_page)){
			$event_general_settings['erp_event_general_settings_checkout_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings);
		}
	$pagecheck = 'Thankyou';
		if( get_page_by_title( $pagecheck ) == NULL ){			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Event_Thankyou]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			); 
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'event_thankyou_page_id', $page_id ); 
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$thank_page=$event_general_settings['erp_event_general_settings_thankyou_page_url'];
			if(empty($thank_page)){
			$event_general_settings['erp_event_general_settings_thankyou_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings);
		}
	$pagecheck = 'Event List';
		
		if( get_page_by_title( $pagecheck ) == NULL ){
			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Event_List]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			);
	
			// Insert the post into the database  
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'event_list_page_id', $page_id ); 
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$list_page=$event_general_settings['erp_event_general_settings_list_page_url'];
			if(empty($list_page)){ 
			$event_general_settings['erp_event_general_settings_list_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings); 
		}	
	$pagecheck = 'Calendar';

		if( get_page_by_title( $pagecheck ) == NULL ){
			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Calendar_View]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			);
	
			// Insert the post into the database  
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'calendar_page_id', $page_id ); 
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$cal_page=$event_general_settings['erp_event_general_settings_calendar_page_url'];
			if(empty($cal_page)){ 
			$event_general_settings['erp_event_general_settings_calendar_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings);  
		}	
	$pagecheck = 'Category Accordion';

		if( get_page_by_title( $pagecheck ) == NULL ){
			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Event_Category_Accordion]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			);
	
			// Insert the post into the database  
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'event_cat_acc_page_id', $page_id ); 
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$acc_cat_page=$event_general_settings['erp_event_general_settings_cat_accor_page_url'];
			if(empty($acc_cat_page)){ 
			$event_general_settings['erp_event_general_settings_cat_accor_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings);
		    
		}	
	$pagecheck = 'Event Category';

		if( get_page_by_title( $pagecheck ) == NULL ){
			
			$createPage1 = array(
			  'post_title'    => $pagecheck,
			  'post_content'  => '[Event_Category]',
			  'post_status'   => 'publish',
			  'post_author'   => 1,
			  'post_type'     => 'page',
			  'post_name'     => $pagecheck
			);
	
			// Insert the post into the database  
			$page_id =  wp_insert_post( $createPage1 );
			update_option( 'event_cat_page_id', $page_id ); 
			$general_setting=array();
			$general_setting=get_option('erp_event_general_settings');
			$cat_page=$event_general_settings['erp_event_general_settings_category_page_url'];
			if(empty($cat_page)){ 
			$event_general_settings['erp_event_general_settings_category_page_url']=$page_id;
			}
		    update_option('erp_event_general_settings',$event_general_settings); 
			
		}			
    }
}
